#version 120
attribute vec3 in_position;
attribute vec3 in_normal;
attribute vec3 in_color;

uniform mat4 projection;
uniform mat4 transform;
uniform mat4 normalTransform;
uniform vec3 directionalLight;

varying float light;
varying vec3 color;

void main() {
	light = dot(normalize(normalTransform * vec4(in_normal, 0)), (vec4(normalize(directionalLight), 0)));
	color = in_color;
	gl_Position = projection * transform * vec4(in_position, 1);
}